#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "md5.h"

typedef void (*md5_block_t)(MD5_CTX *c, const void *data, size_t num);

struct		md5test_s
{
    char	*abcd;
    int		len;
    char	*dat;
};

struct md5test_s	tests[] =
{
      {
	"\x6a\xb9\x40\x2e\x84\x2d\x5e\xf2\x5f\x87\x94\x34\xd4\xa3\xb2\x3d",
	64,
	"\x88\xef\x5c\xab\x7a\x7f\x76\xe6\xf3\x7e\x91\x1c\xbc\x49\x6e\xa5"
	"\xba\x1f\xec\x34\xd1\xa3\xdf\x3d\xe0\xd2\xe4\xd8\x92\x4a\xb7\xc6"
	"\x07\x4f\x90\x1b\x3c\xd9\x76\x18\xfd\xf5\x9f\x24\x05\x9d\xec\x45"
	"\x9f\xc0\xd4\x39\x46\x93\x5e\x72\xc6\x7b\xcd\xdd\x5a\x66\xa1\x1a"
      },
      {
	"\x86\xf4\x2a\x4b\x8a\x09\x62\x9e\xa6\xd5\x16\x8e\x50\xa6\xbc\xf3",
	128,
	"\x63\x7f\x8c\xd1\xbf\x24\x73\x50\xe1\xff\xa7\xd8\xde\xda\xbc\xa9"
	"\x2d\x1f\xd1\x78\xe8\x53\x2e\xe9\x52\xd8\xc4\x59\x4d\x04\xaa\x36"
	"\xcc\x62\x67\x21\x27\x6a\x57\x4e\x37\x73\xa9\xa9\x7a\x84\xff\xb4"
	"\xc6\xa1\x72\xb8\x0e\x00\x48\x1c\xae\x17\x40\xb7\xf2\x4e\x49\xd2"
	"\x75\x45\xdb\x99\x6c\x3d\xd0\xce\x7c\xeb\xa6\xff\x64\x23\x70\xc7"
	"\xf1\xe9\x65\xcb\x6d\xa9\x39\x48\x43\xc6\x02\x02\xb5\xf5\xd1\x7c"
	"\x40\x1a\xff\xd2\xe8\xe5\x46\x26\x20\xd6\x30\x3c\x04\xb9\xe4\x23"
	"\x6e\xc1\x98\x86\x5c\x0a\x4c\x24\x15\x14\xbd\x9c\x8d\xa7\xb8\xcb"
      },
};

void	ctxinit(MD5_CTX *ctx)
{
    ctx->A = 0x67452301;
    ctx->B = 0xefcdab89;
    ctx->C = 0x98badcfe;
    ctx->D = 0x10325476;
    ctx->Nl = ctx->Nh = ctx->num = 0;
}

void	repr(void *_a)
{
    unsigned char	*a = _a;
    int			i;

    for (i = 0; i < 16; i++)
	printf("%02x", a[i]);
}


int	eval(md5_block_t func)
{
    int		ret = 0;
    MD5_CTX	ctx;
    unsigned	ti;

    for (ti = 0; ti < sizeof (tests) / sizeof (*tests); ti++)
      {
	printf("test %d: ", ti);
	ctxinit(&ctx);
	func(&ctx, tests[ti].dat, tests[ti].len / 64);
	if (memcmp(tests[ti].abcd, &(ctx.A), 16))
	  {
	    repr(tests[ti].abcd);
	    printf(" != ");
	    repr(&(ctx.A));
	    printf("\n");
	    ret |= 1;
	  }
	else
	    printf("ok\n");
      }
    return ret;
}

int	main(void)
{
    int		ret = 0;

    printf("\nEvaluating reference implementation (md5_block_host_order)\n");
    ret |= eval(md5_block_host_order);
    printf("\nEvaluating asm implementation (md5_block_asm_host_order)\n");
    ret |= eval(md5_block_asm_host_order);
    return ret;
}
